// $Id: Node.java,v 1.4 2000/11/09 07:17:25 mdean Exp $


/**
 * Viewer representation of a subject
 */
abstract class Node
    implements Comparable
{
    String value;		// URI or (currently, at least) Literal

    /**
     * Statements referencing this node as a subject.
     */
    java.util.Vector subjects = new java.util.Vector();
    /**
     * Statements referencing this node as a property.
     */
    java.util.Vector properties = new java.util.Vector();
    /**
     * Statements referencing this node as a object.
     */
    java.util.Vector objects = new java.util.Vector();

    /**
     * return a shorter name for this node
     */
    String getShortName()
    {
	int pound = value.indexOf('#');
	if (pound == (-1))
	    return value;
	else 
	    return value.substring(pound + 1);
	
    }

    public String toString()
    {
	return value;
    }

    public int compareTo(Object object)
    {
	Node node = (Node) object;

	return value.compareTo(node.value);
    }

    /**
     * retrieve Statement in order listed in subjects or objects.
     */
    public Statement getStatement(int index)
    {
	if (index < subjects.size())
	    {
		return (Statement) subjects.elementAt(index);
	    }
	else 
	    {
		index -= subjects.size();
		return (Statement) objects.elementAt(index);
	    }
    }
}
