// $Id: URIInput.java,v 1.8 2000/11/20 22:33:58 kmbarber Exp $

class URIInput
    extends javax.swing.JFrame
{
    javax.swing.JLabel label;
    javax.swing.JTextField tf;
    javax.swing.JPanel panel;
    javax.swing.JButton fetch;
    javax.swing.JButton browse;
    javax.swing.JFrame frame;
    String fileName;
    
    URIInput ()
    {
	super("DAML Viewer - Open URI");

	frame = this;

	panel = new javax.swing.JPanel();
	label = new javax.swing.JLabel("Please input the desired URI");
	tf = new javax.swing.JTextField("http://www.daml.org/projects/integration/", 100);
	browse = new javax.swing.JButton("Browse for local files");
	browse.addActionListener(new java.awt.event.ActionListener()
				 {
				     public void actionPerformed(java.awt.event.ActionEvent e)
					 {
					     // open a file chooser to select a file ... default to curr directory
					     javax.swing.JFileChooser jfc = new javax.swing.JFileChooser(".");
					     jfc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
					     int retval = jfc.showOpenDialog(frame);
					     if(retval == javax.swing.JFileChooser.APPROVE_OPTION)
						 {
						     fileName = jfc.getSelectedFile().getPath();
						     fileName = fileName.substring(1);
						     String name = "file" + fileName;
						     tf.setText(name); // get rid of c and replace with file
						 }
					 }
				 });
	fetch = new javax.swing.JButton("Fetch");
	fetch.addActionListener(new java.awt.event.ActionListener()
				{
				    public void actionPerformed(java.awt.event.ActionEvent e)
					{
					    if(tf.getText() == null)
						{
						    // make them try again
						}
					    else
						{
						    try { 
							new Viewer(tf.getText());
							frame.dispose(); // XXX get rid of this after its used
						    } catch (Exception ex) {
							ex.printStackTrace();
							System.err.println("Error creating new viewer " + ex);
						    }
						}
					    
					}
				});
	panel.setLayout(new java.awt.GridBagLayout());
	java.awt.GridBagConstraints gbc = new java.awt.GridBagConstraints();
	gbc.insets = new java.awt.Insets(5,5,5,5);
	gbc.gridx = 0;
	gbc.gridy = 0;
	panel.add(label, gbc);
	gbc.gridy = 1;
	gbc.weightx = 1;
	gbc.fill = java.awt.GridBagConstraints.BOTH;
	panel.add(tf, gbc);
	gbc.fill = java.awt.GridBagConstraints.NONE;
	gbc.gridy = 2;
	panel.add(browse, gbc);
	gbc.gridy = 3;
	panel.add(fetch, gbc);
	   
	this.getContentPane().add(panel);
	int width = 300;
	int height = 200;
	java.awt.Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
	int x = (screen.width - width) / 2;
	int y = (screen.height - height) / 2;
	this.setBounds(x, y, width, height);
	this.setVisible(true);
    }
}
